Bug 114 - fc-list :lang=en doesn't list anything
Summary: fc-list :lang=en doesn't list anything
Status: RESOLVED FIXED
Alias: None
Product: fontconfig
Classification: Unclassified
Component: library (show other bugs)
Version: 2.2
Hardware: SPARC Solaris
: high normal
Assignee: Keith Packard
QA Contact:
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2003-09-11 20:21 UTC by Matt Selsky
Modified: 2004-12-03 21:28 UTC (History)
0 users

See Also:
i915 platform:
i915 features:


Attachments

Description Matt Selsky 2003-09-11 20:21:36 UTC
$ fc-list 
Utopia:style=Bold Italic
Bembo MT:style=Regular
Arial:style=Regular
Century Gothic:style=Bold
Times:style=Bold Italic
Utopia:style=Bold
Bembo MT:style=Bold
Bookman Old Style:style=Bold Italic
...

$ fc-list :lang=en
$

I clearly have en fonts.  What's going on?

$ fc-list -V
fontconfig version 2.2.90
$ uname -a
SunOS lisbon 5.9 Generic_112233-08 sun4u sparc

Let me know what other info will be helpful.
Comment 1 Keith Packard 2003-09-11 20:44:21 UTC
First, I'd like to make sure you're running current CVS bits; there were serious
bugs in the language detection code a few weeks ago which have been rectified.

Then, if still broken, it would be useful to know if the language detection code
is completely broken, or just a little bit broken.  For that, it would be
interesting to see what fc-cache produces in a directory with a few fonts that
ostensibly support english.

$ FC_DEBUG=511 fc-cache -f <directory-with-a-few-fonts>

Check to see what that generates.  The Unicode coverage of each font is measured
against the required coverage for each language; the number of Unicode values
not included in the font is printed out like tt(76) or en(0).
Comment 2 Matt Selsky 2003-09-11 21:24:43 UTC
I've upgraded to CVS.

$ fc-list :lang=en
Utopia:style=Bold Italic
Bembo MT:style=Regular
Arial:style=Regular
Century Gothic:style=Bold
Times:style=Bold Italic
Utopia:style=Bold
Bembo MT:style=Bold
...

But this still doesn't work.

$ fc-list :lang=he
$

Here is the debug output:

$ FC_DEBUG=511 ./fc-cache -f /usr/openwin/lib/X11/fonts/Type1/
FC_DEBUG=511
Add Subst match
        pattern any family Equal "mono"
edit
        Edit family Assign "monospace";

Add Subst match
        pattern any family Equal "sans serif"
edit
        Edit family Assign "sans-serif";

Add Subst match
        pattern any family Equal "sans"
edit
        Edit family Assign "sans-serif";

Add Subst match
        pattern any family Equal "Bitstream Vera Serif" Comma "Times" Comma
"Times New Roman" Comma "Nimbus Roman No9 L" Comma "Luxi Serif" Comma "Kochi
Mincho" Comma "AR PL SungtiL GB" Comma "AR PL Mingti2L Big5" Comma "Baekmuk
Batang" Comma "FreeSerif"
edit
        Edit family AppendLast "serif";

Add Subst match
        pattern any family Equal "Bitstream Vera Sans" Comma "Helvetica" Comma
"Arial" Comma "Verdana" Comma "Nimbus Sans L" Comma "Luxi Sans" Comma "Kochi
Gothic" Comma "AR PL KaitiM GB" Comma "AR PL KaitiM Big5" Comma "Baekmuk Dotum"
Comma "SimSun" Comma "FreeSans"
edit
        Edit family AppendLast "sans-serif";

Add Subst match
        pattern any family Equal "Bitstream Vera Sans Mono" Comma "Courier"
Comma "Courier New" Comma "Andale Mono" Comma "Luxi Mono" Comma "Nimbus Mono L"
Comma "NSimSun" Comma "FreeMono"
edit
        Edit family AppendLast "monospace";

Add Subst match
        pattern all family NotEqual "sans-serif"
        pattern all family NotEqual "serif"
        pattern all family NotEqual "monospace"
edit
        Edit family AppendLast "sans-serif";

Add Subst match
        font any family Equal "GulimChe"
edit
        Edit globaladvance Assign false;

Add Subst match
        font any family Equal "DotumChe"
edit
        Edit globaladvance Assign false;

Add Subst match
        font any family Equal "BatangChe"
edit
        Edit globaladvance Assign false;

Add Subst match
        font any family Equal "GungsuhChe"
edit
        Edit globaladvance Assign false;

Add Subst match
        font any family Equal "Bitstream Vera Sans"
        font any pixelsize Less 7.5
edit
        Edit hinting Assign false;

Add Subst match
        font any family Equal "Bitstream Vera Serif"
        font any pixelsize Less 7.5
edit
        Edit hinting Assign false;

Add Subst match
        font any family Equal "Bitstream Vera Sans Mono"
        font any pixelsize Less 7.5
edit
        Edit hinting Assign false;

Add Subst match
        pattern any family Equal "Times"
edit
        Edit family Append "Times New Roman";

Add Subst match
        pattern any family Equal "Helvetica"
edit
        Edit family Append "Arial";

Add Subst match
        pattern any family Equal "Courier"
edit
        Edit family Append "Courier New";

Add Subst match
        pattern any family Equal "serif"
edit
        Edit family Prepend "Bitstream Vera Serif" Comma "Times New Roman" Comma
"Nimbus Roman No9 L" Comma "Luxi Serif" Comma "Times" Comma "Frank Ruehl" Comma
"Kochi Mincho" Comma "AR PL SungtiL GB" Comma "AR PL Mingti2L Big5" Comma
"Baekmuk Batang" Comma "FreeSerif";

Add Subst match
        pattern any family Equal "sans-serif"
edit
        Edit family Prepend "Bitstream Vera Sans" Comma "Verdana" Comma "Nimbus
Sans L" Comma "Luxi Sans" Comma "Arial" Comma "Helvetica" Comma "Nachlieli"
Comma "Kochi Gothic" Comma "AR PL KaitiM GB" Comma "AR PL KaitiM Big5" Comma
"Baekmuk Dotum" Comma "SimSun" Comma "FreeSans";

Add Subst match
        pattern any family Equal "monospace"
edit
        Edit family Prepend "Bitstream Vera Sans Mono" Comma "Andale Mono" Comma
"Courier New" Comma "Luxi Mono" Comma "Nimbus Mono L" Comma "Miriam Mono" Comma
"Kochi Gothic" Comma "AR PL KaitiM GB" Comma "Baekmuk Dotum" Comma "FreeMono";

Add Subst match
        font any slant Equal roman
        pattern any slant NotEqual roman
edit
        Edit matrix Assign matrix Times [1 0.2 0 1];
        Edit slant Assign oblique;

Comment 3 Matt Selsky 2003-09-11 21:33:59 UTC
I copied Arial.ttf to ~/.fonts and re-ran fc-cache.

$ FC_DEBUG=511 ./fc-cache -f ~/.fonts
FC_DEBUG=511
Add Subst match
        pattern any family Equal "mono"
edit
        Edit family Assign "monospace";

[...]
"Arial" "Regular"
        Style Regular maps to slant -1
aa(0) ab(88) 
af(1) { 0149 }
        am(218) ar(125) ast(0) ava(67) ay(0) az(87) ba(82) 
bam(8) { 014a 014b 0186 0190 019d 0254 025b 0272 }
        be(68) bg(60) bh(68) bho(68) bi(0) 
bin(6) { 0300 0301 1eb8 1eb9 1ecc 1ecd }
        bn(89) bo(95) br(0) 
bs(8) { 0106 0107 010c 010d 0110 0111 017d 017e }
        bua(70) 
ca(2) { 013f 0140 }
        ce(67) ch(0) chm(76) chr(85) co(0) cs(16) cu(103) cv(74) cy(12) da(0)
de(0) dz(95) el(67) en(0) eo(12) es(0) 
et(2) { 017d 017e }
        eu(0) fa(129) 
fi(2) { 017d 017e }
        fj(0) fo(0) fr(0) ful(10) fur(0) fy(0) ga(18) gd(0) gez(218) gl(0) 
gn(4) { 0129 0169 1ebd 1ef9 }
        gu(78) gv(0) 
ha(8) { 0181 018a 0198 0199 01b3 01b4 0253 0257 }
        haw(11) he(27) hi(68) ho(0) 
hr(8) { 0106 0107 010c 010d 0110 0111 017d 017e }
        
hu(4) { 0150 0151 0170 0171 }
        hy(77) ia(0) 
ibo(6) { 1eca 1ecb 1ecc 1ecd 1ee1 1ee5 }
        id(0) ie(0) ik(68) io(0) is(0) it(0) iu(161) ja(6538) ka(79) kaa(78) 
ki(4) { 0128 0129 0168 0169 }
        kk(77) 
kl(5) { 0128 0129 0138 0168 0169 }
        km(70) kn(80) ko(16153) kok(68) ks(68) ku(60) kum(66) kv(70) kw(12)
ky(70) la(16) lb(0) lez(67) lo(65) lt(16) lv(24) mg(0) mh(
10) mi(12) mk(42) ml(78) mn(130) mo(72) mr(68) 
mt(8) { 010a 010b 0120 0121 0126 0127 017b 017c }
        my(48) nb(0) ne(68) nl(0) nn(0) no(0) 
ny(2) { 0174 0175 }
        oc(0) om(0) or(79) os(66) pl(16) pt(0) rm(0) 
ro(6) { 0102 0103 0218 0219 021a 021b }
        ru(68) sa(68) sah(76) 
sco(4) { 01b7 021c 021d 0292 }
        se(10) sel(66) sh(76) si(77) sk(16) 
sl(8) { 0106 0107 010c 010d 0110 0111 017d 017e }
        
sm(1) { 02bb }
        sma(0) smj(0) 
smn(8) { 010c 010d 0110 0111 014a 014b 017d 017e }
        sms(18) so(0) sq(0) sr(76) sv(0) sw(0) syr(45) ta(48) te(80) tg(78)
th(87) ti-er(256) ti-et(256) tig(221) tk(74) tl(19) tn(0) 
to(1) { 02bb }
        
tr(5) { 011e 011f 0130 015e 015f }
        ts(0) tt(76) tw(15) tyv(70) ug(125) uk(72) ur(125) uz(68) ven(10)
vi(110) vo(0) 
vot(2) { 017d 017e }
        wa(0) wen(20) 
wo(2) { 014a 014b }
        xh(0) yap(0) yi(27) yo(33) zh-cn(6763) zh-hk(2213) zh-mo(13063)
zh-sg(6763) zh-tw(13063) zu(0) 
done
FcDirCacheWriteDir cache_file "/p/sy/selsky/.fonts/fonts.cache-1"
 write file "Arial.ttf"
 cache written
Comment 4 Keith Packard 2004-12-04 16:28:40 UTC
This works fine for me, fc-list :lang=he | wc -l returns 63 fonts.  Let's assume
it's been fixed at some point.


Use of freedesktop.org services, including Bugzilla, is subject to our Code of Conduct. How we collect and use information is described in our Privacy Policy.